#!/bin/sh
################################################################################
#                                                                              #
# Polish Koders Team 2011                                                      #
#                                                                              #
# contact: http://pkteam.pl/                                                   #
#                                                                              #
################################################################################

#-------------------------------------------------------------------------------
#language section
#-------------------------------------------------------------------------------

  info1="_(PL2303 activated)"
  info2="_(FTDI activated)"
  info3="_(Restart box to save changes!)"
  info4="_(PL2303 & FTDI activated)"
  info5="_(PL2303 & FTDI disabled)"
#-------------------------------------------------------------------------------
#script section
#-------------------------------------------------------------------------------

usbserial_pl2303()
{
 echo serial=pl2303 >/var/config/usbserial.conf
 sync
 echo "$info1"
 echo "\n$info3" 
} 

usbserial_ftdi()
{
 echo serial=ftdi >/var/config/usbserial.conf
 sync
 echo "$info2"
 echo "\n$info3" 
}

usbserial_both()
{
 echo serial=both >/var/config/usbserial.conf
 sync
 echo "$info4"
 echo "\n$info3" 
}

usbserial_disable()
{
 echo serial=off >/var/config/usbserial.conf
 sync
 echo "$info5"
 echo "\n$info3" 
}

status()
{
 . /var/config/usbserial.conf

    if [ $serial == off ]; then
        echo "$info5"
    elif [ $serial == pl2303 ]; then
        echo "$info1"
    elif [ $serial == ftdi ]; then
        echo "$info2"
    elif [ $serial == both ]; then
        echo "$info4"
    fi
}

#-------------------------------------------------------------------------------
#use section
#-------------------------------------------------------------------------------

case "$1" in
 'pl2303')
    usbserial_pl2303
    ;;
 'ftdi')
    usbserial_ftdi
    ;;
 'both')
    usbserial_both
    ;;
 'off')
    usbserial_disable
    ;;
 'status')
    status
    ;;
 *)
    echo -e "\nUse: usbserial.sh pl2303|ftdi|both|off|status"
    ;;
esac

echo ""
exit 0
