#!/bin/sh
################################################################################
#                                                                              #
# Polish Kathi Team 2010                                                       #
#                                                                              #
# contact: http://pkteam.pl                                                    #
#                                                                              #
################################################################################

. /var/config/memory

#-------------------------------------------------------------------------------
#script section
#-------------------------------------------------------------------------------
howto()
{
 echo "_(NOTE: When wireless mode is enable LAN interface is down)"
 echo "_(If You need to re-use LAN interface You need to disable wireless support and restart tuner)" "\n"
 echo "_(If You want to use WLAN interface You need perform 3 steps:)"
 echo "_(1. Setup connection)"
 echo "_(2. Setup WLAN network)"
 echo "_(3. Re/Start Wi-Fi network)" "\n"
 echo "_(You can check if connection has been established by running the option: 'connection status')"
}

rt3070_on()
{
 echo wlan=rt3070 >/var/config/wlan.conf
 sync
 insmod /lib/modules/rt3070sta.ko
 ifconfig ra0 up
 echo "_(Ralink RT3070 driver loaded)" "\n"
 if [ $memory == 128MB ]; then
    mac=`ifconfig ra0 | grep HWaddr | awk '{print $5}'`
    echo "_(Detected Wi-Fi MAC: )" $mac "\n"
    echo "_(IMPORTANT: You have to restart GUI or reboot UFS910 before setup: WLAN network configuration)" "\n"
 else
    echo "_(Detected 64MB UFS910)"
    echo "_(IMPORTANT: There is a known bug on ufs910 with 64MB of memory - can not initialize wifi interface. UFS910 is required to reboot before next 3 steps configuration for proper functioning of the wireless adapter)" "\n"
 fi
 howto
}

rt2870_on()
{
 echo wlan=rt2870 >/var/config/wlan.conf
 sync
 insmod /lib/modules/rt2870sta.ko
 ifconfig ra0 up
 echo "_(Ralink RT2870 driver loaded)" "\n"
 if [ $memory == 128MB ]; then
    mac=`ifconfig ra0 | grep HWaddr | awk '{print $5}'`
    echo "_(Detected Wi-Fi MAC: )" $mac "\n"
    echo "_(IMPORTANT: You have to restart GUI or reboot UFS910 before setup: WLAN network configuration)" "\n"
 else
    echo "_(Detected 64MB UFS910)"
    echo "_(IMPORTANT: There is a known bug on ufs910 with 64MB of memory - can not initialize wifi interface. UFS910 is required to reboot before next 3 steps configuration for proper functioning of the wireless adapter)" "\n"
 fi
 howto
}

rt73_on()
{
 echo wlan=rt73 >/var/config/wlan.conf
 sync
 insmod /lib/modules/rt73.ko
 iwconfig wlan0 mode managed
 ifconfig wlan0 up
 echo "_(Ralink RT73 driver loaded)" "\n"
 if [ $memory == 128MB ]; then
    mac=`ifconfig wlan0 | grep HWaddr | awk '{print $5}'`
    echo "_(Detected Wi-Fi MAC: )" $mac "\n"
    echo "_(IMPORTANT: You have to restart GUI or reboot UFS910 before setup: WLAN network configuration)" "\n"
 else
    echo "_(Detected 64MB UFS910)"
    echo "_(IMPORTANT: There is a known bug on ufs910 with 64MB of memory - can not initialize wifi interface. UFS910 is required to reboot before next 3 steps configuration for proper functioning of the wireless adapter)" "\n"
 fi
 howto
}

wifi_off()
{
 echo wlan=off >/var/config/wlan.conf
 sync
 ifconfig ra0 down 2>/dev/null
 ifconfig wlan0 down 2>/dev/null
 rmmod rt3070sta 2>/dev/null
 rmmod rt2870sta 2>/dev/null
 rmmod rt73 2>/dev/null
 echo "_(Wi-Fi drivers deactivated)" "\n"
 echo "_(You can now use LAN interface after tuner reboot)"
}

network_restart()
{
 /etc/init.d/networking wifi-restart
}

#-------------------------------------------------------------------------------
#use section
#-------------------------------------------------------------------------------

case "$1" in
 'rt3070')
    rt3070_on
    ;;
 'rt2870')
    rt2870_on
    ;;
 'rt73')
    rt73_on
    ;;
 'off')
    wifi_off
    ;;
 'restart')
    network_restart
    ;;
 *)
    echo -e "\nUse: wlan.sh rt3070|rt2870|rt73|off|restart"
    ;;
esac

echo ""
exit 0
